<template>
    <div :class="$style.chart">
        <div class="text1" :class="$style.title">{{ title }}</div>
        <Line :data="chartData" :options="chartOptionsObj"> </Line>
    </div>
</template>

<script>
import { Chart as ChartJS, CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip } from 'chart.js'
import { Line } from 'vue-chartjs'
// eslint-disable-next-line
// import * as chartConfig from './chartConfig.js'

ChartJS.register(CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip)

export default {
    name: 'ChartComponent',
    components: {
        Line,
    },

    props: {
        title: {
            type: String,
            default: '',
        },
        chartData: {
            type: Object,
            default: () => ({}),
        },
        chartOptions: {
            type: Object,
            default: () => ({}),
        },
    },

    data() {
        return {
            defaultChartOptions: {
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            drawTicks: false,
                        },
                        // border: {
                        //     dash: [5, 10],
                        // },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
            },
        }
    },

    computed: {
        chartOptionsObj() {
            return {
                ...this.chartOptions,
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            drawTicks: false,
                        },
                        // border: {
                        //     dash: [5, 10],
                        // },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
                //-----------------------
                plugins: {
                    tooltip: {
                        callbacks: {
                            label: function (context) {
                                let label = context.dataset.label || ''

                                if (label) {
                                    label += ': '
                                }
                                if (context.parsed.y !== null) {
                                    label += new Intl.NumberFormat('en-US', {
                                        style: 'currency',
                                        currency: 'USD',
                                    }).format(context.parsed.y)
                                }
                                return label
                            },
                        },
                    },
                },
            }
        },
    },
}
</script>

<style module>
.chart {
    height: 250px;
}
.title {
    margin-bottom: 16px;
    font-size: 16px;
    font-weight: 700;
    line-height: 20px;
}
</style>
